#include "../include/standard.h"
#include "../include/typedefs.h"
#include "../include/definitions.h"
#include "../include/utillib.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Pos::debug_force_enm(System &system)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

 int  i,j;
 int iatm1, iatm2, iatm3, three, ndatom;
 int itors1, itors2, itors3, ndtors;
 int int_arg, debug_all, debug_three;

 double eps, V0, V1; 
 double   fx_num, fx_an, fy_num, fy_an, fz_num, fz_an;
 double ft_num, ft_an;

 int ntors_tr = system.tors_defs.num_trans;
 long *seed   = &(system.general.seed);

 print_doubleline();
 printf(">>Debug Elastic Network Model forces<<\n");
 print_line();


/*-------------------------------------------------------------------------*/
/* I) Make a random perturbation on the system, otherwise forces are zero  */

    LINE
    printf("Test could be performed either at the minimum Rmin \n");
    printf("Or a random perturbatim from the minimum Rmin+eta*Rmin\n");
    printf("Please type \"1\" if interested a test at Rmin \n");
    printf("Please type \"2\" if interested a test at Rmin+eta*Rmin\n");
    scanf("%d", &int_arg); 
    LINE

    if (int_arg==2) {/*perform perturbation*/
      if (system.general.prop_type==1) {/*cartesian*/
           for (i=1;i<=natom;i++) {
               x[i] += ran1(seed);
               y[i] += ran1(seed);
               z[i] += ran1(seed);
           }/*endfor*/
      }/*endif-cartesian*/
      if (system.general.prop_type==2) {/*torsional*/
	   update_xyz();
	   update_xi_yi_zi();
           tors_transformXtoT();
           eps = 1.e-3;
           for (i=1;i<=ntors_tr;i++) {
	        t[i] += eps*ran1(seed);
           }
           tors_transformTtoX();
           acc_propose();
      }/*endif-torsional*/
    }/*endif*/

/*-------------------------------------------------------------------------*/
/* II) Debug Cartesian Coordinates                                         */
 if (system.general.prop_type==1) {/*cartesian propagation*/
    debug_all   = 0;
    debug_three = 0;
    LINE
    printf("Test could be performed either on all \"atoms\" \n");
    printf("or a selected set (three) of \"atoms\". The former \n");
    printf("choice will take more time! \n");
    printf("Please type \"1\" if interested in all \"atoms\"\n");
    printf("Please type \"2\" if interested in a selected set of \"atoms\"\n");
    scanf("%d", &int_arg); 
    if (int_arg==1) {debug_all   = 1;}
    if (int_arg==2) {debug_three = 1;}
    if (debug_three) {
        LINE
        printf("Please give the indices of three \"atoms\" \n");
        three = 3;
        scanf("%d %d %d", &iatm1, &iatm2, &iatm3); 
        ndatom = three;
    }/*debug_three*/
    if (debug_all)   {ndatom = natom;}
        potential_enm();
        update_xyz();
        V0 = ebond_enm;
        eps = 1.e-6;
        for (i=1;i<=ndatom;i++) {
           if (debug_three) {
              if (i==1) {j = iatm1;}    
              if (i==2) {j = iatm2;}
              if (i==3) {j = iatm3;}
           }/*debug_three*/
           if (debug_all) {j=i;}
           update_x_y_z();
           force_enm();
           fx_an  = fx[j];
           x[j] += eps;
           potential_enm();
           V1 = ebond_enm;
           fx_num = -(V1-V0)/eps;
                   
           update_x_y_z();
           force_enm();
           fy_an  = fy[j];
           y[j] += eps;
           potential_enm();
           V1 = ebond_enm;
           fy_num = -(V1-V0)/eps;
          
           update_x_y_z();
           force_enm();
           fz_an  = fz[j];
           z[j] += eps;
           potential_enm();
           V1 = ebond_enm;
           fz_num = -(V1-V0)/eps;
          
           printf("\n\t atom %d fx_num %g fx_an %g  \n",j,fx_num,fx_an);
           printf("\t atom %d fy_num %g fy_an %g  \n",j,fy_num,fy_an);
           printf("\t atom %d fz_num %g fz_an %g  \n",j,fz_num,fz_an);
        }/*endfor*/
 }/*cartesian propagation*/


/*-------------------------------------------------------------------------*/
/* II) Debug Torsional Coordinates                                         */
 if (system.general.prop_type==2) {/*torsional propagation*/
    debug_all   = 0;
    debug_three = 0;
    LINE
    printf("Test could be performed either on all \"torsions\" \n");
    printf("or a selected set (three) of \"torsions\". The former \n");
    printf("choice will take more time! \n");
    printf("Please type \"1\" if interested in all \"torsions\"\n");
    printf("Please type \"2\" if interested in a set of \"torsions\"\n");
    scanf("%d", &int_arg); 
    if (int_arg==1) {debug_all   = 1;}
    if (int_arg==2) {debug_three = 1;}
    if (debug_three) {
        LINE
        printf("The number of primary dihedrals: %d\n",ntors_tr); 
        printf("Please give the indices of three \"dihedrals\" \n");
        three = 3;
        scanf("%d %d %d", &itors1, &itors2, &itors3);
        ndtors = three;
    }/*debug_three*/
    if (debug_all)   {ndtors = ntors_tr;}
    potential_enm();
    update_xyz();
    V0 = ebond_enm;
    eps = 1.e-7;   
    for (i=1;i<=ndtors;i++) {
      if (debug_three) {
         if (i==1) {j = itors1;}
         if (i==2) {j = itors2;}
         if (i==3) {j = itors3;}
      }
      if (debug_all) {j=i;}
      update_x_y_z();
      force_enm();
      update_xi_yi_zi();
      tors_transformXFXtoTFT();
      ft_an = ft[j];
      t[j] += eps;
      tors_transformTtoX();
      copy_3vec_to_3vec(xi,yi,zi,x,y,z,natom);
      potential_enm();
      V1 = ebond_enm;
      ft_num = -(V1-V0)/eps;
         
      printf("\n\t dihedral %d fx_num %g fx_an %g  \n",j,ft_num,ft_an);
    }/*endfor*/
 }/*torsional propagation*/

    
 printf("\n\n");
 printf("system.bond.energy_enm(this) %g system.bond.getPot_enm(this) %g\n",
                   system.bond.energy_enm(this),system.bond.getPot_enm(this));
 LINE

 print_line();
 printf("Completed >>Debug Elastic Network Model forces<<\n");
 print_doubleline();


/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/
