#ifndef SIM_SCORE_MATRIX_H_
#define SIM_SCORE_MATRIX_H_

#include "emdata.h"
#include <iostream>
#include "pointarray.h"
#include "Orientation_Score.h"

using namespace EMAN;
using namespace std;

class Sim_Score_Matrix
{
public:
	Sim_Score_Matrix();
	
	float compare_with_em2d(EMData * proj, EMData * image_fft_amp);
	
	void calc_sim_score_matrix(PointArray *new_pa, const char * em_image_file, float old_az, float old_alt, float old_phi, float apix, float res);
	
	Orientation_Score * get_sim_score_matrix() {
		return score_matrix;
	}
	
	virtual ~Sim_Score_Matrix();
	
	//set the euler range/interval and calculate the matrix dimension
	void set_sim_score_matrix_dim(float new_euler_range, float new_euler_interval) {
		euler_range=new_euler_range;
		euler_interval=new_euler_interval;
		score_matrix_dim = (int)(euler_range/euler_interval*2+1);
	}
	
	int get_sim_score_matrix_dim() {
		return score_matrix_dim;
	}
	
	void init_sim_score_matrix() {
		score_matrix = new Orientation_Score[score_matrix_dim*score_matrix_dim*score_matrix_dim];  // Allocate n ints and save ptr in a.
	}
	
	float get_euler_range() {
		return euler_range;
	}
	
	void set_euler_range(float new_euler_range) {
		euler_range=new_euler_range;
	}	
	
	float get_euler_interval() {
		return euler_interval;
	}
	
	void set_euler_interval(float new_euler_interval) {
		euler_interval=new_euler_interval;
	}
	
	void dump_sim_score_matrix();
	
	void order_sim_score_matrix();
	
private:
	float euler_range;
	float euler_interval;
	int score_matrix_dim;
	Orientation_Score * score_matrix;
};

#endif /*SIM_SCORE_MATRIX_H_*/
