#include "definitions_const.h"

#define MIN(A,B) (((A)<(B))?(A):(B))
#define MAX(A,B) (((A)>(B))?(A):(B))
#define MAX3(A,B,C) (MAX(MAX((A),(B)),(C)))
#define P16 setprecision(16)
#define LINE printf("\n");

extern char err_msg[LINE_NCHARMAX];
extern char wrn_msg[LINE_NCHARMAX];

/*--------------------------------------------------------------------------*/
/* interface/ran1.cpp - declarations */

float ran1(long *);

/*--------------------------------------------------------------------------*/
/* interface/mb.cpp - declarations */

double mb(double,double,long *);
double vdw(double); 
double fdw(double); 

/*--------------------------------------------------------------------------*/
/* prototyping classes for the following declarations */

class General;
class Chain; 
class System;
class Pos;
class Tors_defs;
class Stage_defs;

/*--------------------------------------------------------------------------*/
/* main/debug.cpp - declarations */

void debug(System&);

/*--------------------------------------------------------------------------*/
/* main/conf_sampl_pt.cpp - declarations */

void conf_sampl_pt(System&);

/*--------------------------------------------------------------------------*/
/* main/conf_sampl_ptrepswa.cpp - declarations */

void conf_sampl_ptrepswa(System&);

/*--------------------------------------------------------------------------*/
/* main/conf_sampl_ptstage.cpp - declarations */

void conf_sampl_ptstage(System&);

/*--------------------------------------------------------------------------*/
/* main/minimize.cpp - declarations */

void minimize(System&);

/*--------------------------------------------------------------------------*/
/* main/md.cpp - declarations */

void md(System&);

/*--------------------------------------------------------------------------*/
/* main/normal_mode.cpp - declarations */

void normal_mode(System&);

/*--------------------------------------------------------------------------*/
/* main/normal_mode_stg.cpp - declarations */

void normal_mode_stg(System&);

/*--------------------------------------------------------------------------*/
/* main/normal_mode_enm.cpp - declarations */

void normal_mode_enm(System&);

/*--------------------------------------------------------------------------*/
/* main/conf_sampl_eemc.cpp - declarations */

void conf_sampl_eemc(System&);

/*--------------------------------------------------------------------------*/
/* main/seq_sampl_pt.cpp - declarations */

void seq_sampl_pt(System&);

/*--------------------------------------------------------------------------*/
/* main/seq_sampl_eemc.cpp - declarations */

void seq_sampl_eemc(System&);

/*--------------------------------------------------------------------------*/
/* main/conf_sampl_eemc_pt.cpp - declarations */

void conf_sampl_eemc_pt(System&);

/*--------------------------------------------------------------------------*/
/* output/output.cpp - declarations */

void statistics(Chain*,System&);
void output(Chain*,System&);
void output(Pos *,System&);


/*--------------------------------------------------------------------------*/
/* torsion/adjust.cpp - declarations */

void adjust(Pos *,System& ,int);

/*--------------------------------------------------------------------------*/
/* torsion/adjust.cpp - declarations */

void adjust(Pos *,System& ,int,int);

/*--------------------------------------------------------------------------*/
/* torsion/translate.cpp - declarations */

void translate(Pos *,Tors_defs *,int,int);

/*--------------------------------------------------------------------------*/
/* torsion/rotate.cpp - declarations */

void rotate(Pos *,Tors_defs *,int,int);   

/*--------------------------------------------------------------------------*/
/* torsion/resolve.cpp - declarations */

void resolve(Pos *,Tors_defs *,int,int);

/*--------------------------------------------------------------------------*/
/* torsion/group.cpp - declarations */

void group(Pos *,Tors_defs *,int,int);  

/*--------------------------------------------------------------------------*/
/* torsion/group.cpp - declarations */

void prop_tors(Pos *,General *,Tors_defs *,int);  

/*--------------------------------------------------------------------------*/
/* torsion/closure.cpp - declarations */

int closure(Pos *,Tors_defs *,int,int);   

/*--------------------------------------------------------------------------*/
/* transform/stage/stage_closed_transform.cpp - declarations */

void stage_closed_transform(Pos *,Stage_defs *,int,int);

/*--------------------------------------------------------------------------*/
/* transform/stage/stage_open_transform.cpp - declarations */

void stage_open_transform(Pos *,Stage_defs *,int,int);

/*--------------------------------------------------------------------------*/
/* mathlib/mathlib.cpp - declarations */

void spline(double*,double*,int,double,double,double*);
void splint(double*,double*,double*,int,double,double*);
void dsplint(double*,double*,double*,int,double,double*);
void nspline(double*  x,
             double*  y,
             int      N,
             double*  derivatives);
void nsplint(double*  x,
             double*  y,
             double*  derivatives,
             int      N,
             double   xintrp,
             double   *yintrp);
void nsplint(double*  x,
             double*  y,
             double*  derivatives,
             int      N,
             int      ns,
             int&     nf,
             double   xintrp,
             double   *yintrp);
void ndsplint(double*  x,
              double*  y,
              double*  derivatives,
              int      N,
              int      ns,
              int&     nf,
              double   xintrp,
              double   *yintrp);
void ndsplint(double* x,
              double* y,
              double* derivatives,
              int     N,
              double  xintrp,
              double  *dy_dx);
void cputime(double*);
double heavyside(double);
double heavyside_dot(double);
double switch_left(double,double,double,int); 
double switch_right(double,double,double,int); 
double dx_switch_right(double,double,double,int); 
double ddd_eps(double,double,double,double,int);
double ddd_deps(double,double,double,double,int);
void ran_md_gen( double & );
double pythag(double,double);
double** dmatrix(long,long,long,long);
int** imatrix(long,long,long,long);
double* dvector(long,long);
int* ivector(long,long);
char* cvector(long,long);
void free_dvector(double*,long,long);
void free_ivector(int*,long,long);
void free_cvector(char*,long,long);
void free_dmatrix(double**,long,long,long,long);
void free_imatrix(int**,long,long,long,long);
void mat_mat(double**,double**,double**,int);
void mat_add(double**,double**,double**,int);
void mat_add(double**,double**,double**,double**,int);
void mat_app(double**,double,double**,int); 
void vec_add(double*,double*,double*,int);
void vec_add(double*,double*,double*,double*,int);
void scal_mat(double,double**,int);
void scal_vec(double,double*,int);
double vec_vec(double*,double*,int);
void mat_vec(double**,double*,double*,int);
void vec_mat(double*,double**,double*,int);
void mat_trn(double**,double**,int); 
void mat_out(double**,int);
void mat_comp_out(double**,double**,int);
void vec_comp_out(double*,double*,int); 
void vec_out(double*,int);
void colcopy_mat_to_vec(double**,double*,int,int); 
void copy_vec_to_vec(double*,double*,int);
void copy_3vec_to_3vec(double*,double*,double*,double*,double*,double*,int);
void copy_3vec_to_vec(double*,double*,double*,double*,int);
void copy_vec_to_3vec(double*,double*,double*,double*,int);  
void nrerror(char error_text[]);
void tred2(double**,int,double*,double*);
void tqli(double*,double*,int,double**);
void eigsrt(double*,double**,int);
void gaucof(int,double*,double*,double,double*,double*); 
void pbc_0_2Pi(double*,int);
double linsin(double);

/*--------------------------------------------------------------------------*/
/* mathlib/intra_mathlib.cpp - declarations */

void cprd(double,double,double,double,double,double,
                                        double *,double *,double *);
double getDistOnfo(double*,double*,double*,int,int);
double getTorsAngle(double*,double*,double*,int,int,int,int);
double getBendAngle(double*,double*,double*,int,int,int);
  
/*--------------------------------------------------------------------------*/
/* mathlib/trans_mathlib.cpp - declarations */ 

void d_axb_da_(double*,double**);
void d_axb_db_(double*,double**);
void d_axb_n_da_(double*,double*,double**,double**,double**);
void d_axb_n_db_(double*,double*,double**,double**,double**);
void dR_dr_(double**,double**,double**,
           double**,double**,double**);
void dRT_dr_(double**,double**,double**,
           double**,double**,double**);
void de_dra_(double*,double*,double*,double**);
void de_drb_(double*,double*,double*,double**);  
void dRa_dr_(double **,double **,double **,
             double *,double **,double*);                         
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/* mathlib/minimize/cg_min.cpp - declarations */ 

void frprmn(double*,int,double,int*,double*,double (*)(double*), 
	                                      void (*)(double*,double*));

/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/* mathlib/minimize/bfgs_min.cpp - declarations */ 

void dfpmin(double*,int,double,int*,double*,double (*)(double*), 
	                                      void (*)(double*,double*));

/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/* energy/energy_global.cpp - declarations */ 

double potential_cart(double*);
double potential_tors(double*);
double potential_bend(double*);

/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/* energy/denergy_global.cpp - declarations */ 

void dpotential_cart(double*,double*);
void dpotential_tors(double*,double*);
void dpotential_bend(double*,double*);

/*--------------------------------------------------------------------------*/
