#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Coord::setup(System &system)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

     int i;

     natom = system.pos.natom;
     action_type = system.general.action_type;

     if ((action_type==1)||(action_type==2)) {/*conformation sampling*/    
        x    = new double[natom] - 1; 
        y    = new double[natom] - 1; 
        z    = new double[natom] - 1;
     }
     else if ((action_type==3)||(action_type==4)) {/*sequence sampling*/
        x    = new double[natom] - 1; 
        y    = new double[natom] - 1; 
        z    = new double[natom] - 1;
        permute_seq = new int[natom] - 1;
        for (i=1;i<=natom;i++) {
            x[i] = system.pos.x[i];
            y[i] = system.pos.y[i];
            z[i] = system.pos.z[i];
            permute_seq[i] = system.pos.permute_seq[i]; 
        }  
     }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/

/*=========================================================================*/
double Coord::potential(System &system)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

   Pos pos;
   double pot;

   pos.chrg = system.pos.chrg;
   pos.x = x;
   pos.y = y;
   pos.z = z;
   pos.permute_seq = permute_seq;

   pot = 0.0;       

   if ((action_type==1)||(action_type==2)) {/*conformation sampling*/
        pot = epot;
   }
   else if ((action_type==3)||(action_type==4)) {/*sequence sampling*/
      pot += system.inter.getPotPermute(&pos);
   }
      
   return pot;
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


