#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"


/*=========================================================================*/
void Disk::add(Chain chain, long* seed)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
       
     int ith;
     double eps = 1.e-15;
     if (length > max_size-1) {
        ith = (int)((ran1(seed)-eps)*((double)length)) + 1;
        stock[ith] = chain;
     } 
     else { 
        length++; 
        stock[length] = chain;
     }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Disk::setup(System &system)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

     int i;
     int natom       = system.pos.natom;
     int action_type = system.general.action_type; 
     max_size = system.general.mdisk;
     if ((action_type==1)||(action_type==2)) {/*conformational sampling */
        stock = new Coord[max_size+1];
        for (i=0;i<=max_size;i++) {
            stock[i].action_type = action_type;
            stock[i].natom = natom;
	    stock[i].x   =  new double[natom] - 1;
            stock[i].y   =  new double[natom] - 1;
            stock[i].z   =  new double[natom] - 1;
        }
     }
     else if ((action_type==3)||(action_type==4)) {/*sequence sampling*/
        stock = new Coord[max_size+1];
        for (i=0;i<=max_size;i++) {
            stock[i].action_type = action_type;
            stock[i].natom = natom;
	    stock[i].permute_seq = new int[natom] - 1;
        }
     }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/
