#include "../include/standard.h"
#include "../include/typedefs.h"
#include "../include/definitions.h"

#define M_PI 3.14159265358979323846


float ran1(long * );

double mb(double m, double T, long* seed) 
// Maxwel Boltzman sampling of particle velocities
// m: mass, T: temperature  
{
   double sig,chi,psi,eta;
   double v;

   sig = sqrt(T/m);
   chi = ran1(seed);
   psi = ran1(seed);
   eta = sqrt(-log(chi+1.e-30))*sqrt(2.0)*cos(2.0*M_PI*psi);
   v   = sig*eta;

   return v;
}  


void Pos::vel_sampl( System &system ) {
 
  int j;
  long *seed = &(system.general.seed);

    for (j=1;j<=natom;j++) {
        vx[j] = mb(mass[j],T,seed);
        vy[j] = mb(mass[j],T,seed);
        vz[j] = mb(mass[j],T,seed);
    }

}
