#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"


/*=========================================================================*/
void Chain::operator=( Coord& coord )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

   pos = coord;

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Chain::operator=( Chain& chain )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

   int i;
   int natom = pos.natom;
   
   if ((action_type==1)||(action_type==2)) {
      for (i=1;i<=natom;i++) {
           pos.x[i]  = chain.pos.x[i];
           pos.y[i]  = chain.pos.y[i];
           pos.z[i]  = chain.pos.z[i];        
       }
       pos.ebond  = chain.pos.ebond;
       pos.ebend  = chain.pos.ebend;
       pos.etors  = chain.pos.etors;
       pos.eonfo  = chain.pos.eonfo;
       pos.einter = chain.pos.einter;
       pos.epot   = chain.pos.epot;
   }  
   else if ((action_type==3)||(action_type==4)) {
      for (i=1;i<=natom;i++) {
          pos.permute_seq[i] = chain.pos.permute_seq[i];
      }
   }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Coord::operator=( Coord& coord )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

   int i;

   if ((action_type==1)||(action_type==2)) {
      for (i=1;i<=natom;i++) {
          x[i] = coord.x[i];
          y[i] = coord.y[i];
          z[i] = coord.z[i];        
      }        
      ebond  = coord.ebond;
      ebend  = coord.ebend;
      etors  = coord.etors;
      eonfo  = coord.eonfo;
      einter = coord.einter;
      epot   = coord.epot;
   }  
   else if ((action_type==3)||(action_type==4)) {
      for (i=1;i<=natom;i++) {
          permute_seq[i] = coord.permute_seq[i];
      }
   }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Coord::operator=( Chain& chain )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
/* Used in EEMC, Disk::add                                                 */
/*-------------------------------------------------------------------------*/

   int i;

   if ((action_type==1)||(action_type==2)) {
      for (i=1;i<=natom;i++) {
          x[i] = chain.pos.x[i];
          y[i] = chain.pos.y[i];
          z[i] = chain.pos.z[i];        
      }
      ebond  = chain.pos.ebond;
      ebend  = chain.pos.ebend;
      etors  = chain.pos.etors;
      eonfo  = chain.pos.eonfo;
      einter = chain.pos.einter;
      epot   = chain.pos.epot;
   }  
   else if ((action_type==3)||(action_type==4)) {
      for (i=1;i<=natom;i++) {
          permute_seq[i] = chain.pos.permute_seq[i];        
      }
   }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::operator=( Coord& coord )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

   int i;

   if ((action_type==1)||(action_type==2)) {
      for (i=1;i<=natom;i++) {
          x[i] = coord.x[i];
          y[i] = coord.y[i];
          z[i] = coord.z[i];        
      }
      ebond  = coord.ebond;
      ebend  = coord.ebend;
      etors  = coord.etors;
      eonfo  = coord.eonfo;
      einter = coord.einter;
      epot   = coord.epot;
   }  
   else if ((action_type==3)||(action_type==4)) {
      for (i=1;i<=natom;i++) {
          permute_seq[i] = coord.permute_seq[i];
      }
   }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/

