#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"
#include "../include/utillib.h"
#include "../include/cmalloc.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Pos::update_xyz()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {
         xyz[3*(i-1)+1] = x[i];
         xyz[3*(i-1)+2] = y[i];
         xyz[3*(i-1)+3] = z[i];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_xyzc()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {
         xyzc[3*(i-1)+1] = xc[i];
         xyzc[3*(i-1)+2] = yc[i];
         xyzc[3*(i-1)+3] = zc[i];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_fxyz()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {
         fxyz[3*(i-1)+1] = fx[i];
         fxyz[3*(i-1)+2] = fy[i];
         fxyz[3*(i-1)+3] = fz[i];
    }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/



/*=========================================================================*/
void Pos::update_dxyz()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {
         dxyz[3*(i-1)+1] = -fx[i];
         dxyz[3*(i-1)+2] = -fy[i];
         dxyz[3*(i-1)+3] = -fz[i];
    }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_dt()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    System *system = this->system_ptr;
    int ntors_tr   = system->tors_defs.num_trans;

    for (i=1;i<=ntors_tr;i++) {
         dt[i] = -ft[i];
         dt[i] = -ft[i];
         dt[i] = -ft[i];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_x_y_z()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {
         x[i]  = xyz[3*(i-1)+1];
         y[i]  = xyz[3*(i-1)+2];
         z[i]  = xyz[3*(i-1)+3];
    }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_xi_yi_zi()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {
         xi[i]  = xyz[3*(i-1)+1];
         yi[i]  = xyz[3*(i-1)+2];
         zi[i]  = xyz[3*(i-1)+3];
    }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_fx_fy_fz()
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i; 

    for (i=1;i<=natom;i++) {         
         fx[i] = fxyz[3*(i-1)+1];
         fy[i] = fxyz[3*(i-1)+2];
         fz[i] = fxyz[3*(i-1)+3];
    }

/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_uxyzbb( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i,ii; 

    int  *ind_atm_bb   =   system.maps.ind_atm_bb;

    for (i=1;i<=natm_bb;i++) {
         ii = ind_atm_bb[i];
         uxyzbb[3*(i-1)+1] = ux[ii];
         uxyzbb[3*(i-1)+2] = uy[ii];
         uxyzbb[3*(i-1)+3] = uz[ii];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_uxbb_uybb_uzbb( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i,ii; 

    int  *ind_atm_bb   =   system.maps.ind_atm_bb;

    for (i=1;i<=natm_bb;i++) {
         ii = ind_atm_bb[i];
         ux[ii] = uxyzbb[3*(i-1)+1];
         uy[ii] = uxyzbb[3*(i-1)+2];
         uz[ii] = uxyzbb[3*(i-1)+3];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_uxyzcbb( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i,ii; 

    int  *ind_atm_bb   =   system.maps.ind_atm_bb;

    for (i=1;i<=natm_bb;i++) {
         ii = ind_atm_bb[i];
         uxyzcbb[3*(i-1)+1] = ux[ii];
         uxyzcbb[3*(i-1)+2] = uy[ii];
         uxyzcbb[3*(i-1)+3] = uz[ii];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_fuxyzbb( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i,ii; 

    int  *ind_atm_bb   =   system.maps.ind_atm_bb;

    for (i=1;i<=natm_bb;i++) {
         ii = ind_atm_bb[i];
         fuxyzbb[3*(i-1)+1] = fux[ii];
         fuxyzbb[3*(i-1)+2] = fuy[ii];
         fuxyzbb[3*(i-1)+3] = fuz[ii];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/


/*=========================================================================*/
void Pos::update_duxyzbb( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/
    int i,ii; 

    int  *ind_atm_bb   =   system.maps.ind_atm_bb;

    for (i=1;i<=natm_bb;i++) {
         ii = ind_atm_bb[i];
         duxyzbb[3*(i-1)+1] = -fux[ii];
         duxyzbb[3*(i-1)+2] = -fuy[ii];
         duxyzbb[3*(i-1)+3] = -fuz[ii];
    }
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/

