#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"

#define DEBUG
#undef DEBUG

void conf_sampl_eemc_pt( System &system ) {

    int i,j,n,k,ith;
    int ptemp;
    long  *seed = &(system.general.seed);
// system parameters
    int    nstep_mc = system.general.nstep_mc;
    int    nstat    = system.general.nstat;
    double pee      = system.general.pee;
    double length,pacc;
    double x_pot, y_pot;
    Coord  y;
// burn in periods
    int B = system.general.B;
    int N = system.general.N;
// EEMC local impulse
    int neemc_count = 0;
// MH Chain
    int K  =  system.general.n_chains_mc;
    Chain *X;
    X = new Chain[K+1];
    double T[K+1];
    double pi_iy,pi_ix,pi_ip1y,pi_ip1x;
// Machine eps
    double eps = 1.e-15;
// PT vs. (EEMC+PT) relative frequency
    double pt_freq = 0.8;
// Disks
#ifdef DEBUG
   printf(" Check point 0\n");
   getchar();
#endif
   Disk **D;
   for (int iD=0;iD<=K+1;iD++) {
        D[iD] = new Disk[K+1];
   }
#ifdef DEBUG
   printf(" Check point I\n");
   getchar();
#endif
// Only EEMC exchange
   ptemp = 1;
// Initialize
    y.setup(system);
    for (k=0;k<=K;k++) {
        X[k].setup(k,system);
        T[k] = system.energy_part.T[k];
        for (j=0;j<=K;j++) {
	    D[k][j].setup(system);
	}
    }
#ifdef DEBUG
   printf(" Check point III\n");
   getchar();
#endif
// MC Chain
    for (n=1;n<=nstep_mc;n++) {

        if (neemc_count==50) {ptemp=1;}
        if ((n % 1000)==0) {
             ptemp = 0;
             neemc_count = 0;
//             if (pt_freq > ran1(seed)) {ptemp=1;}
        }
        if (ptemp==0) {neemc_count++;}

        for (i=K;i>=0;i--) {
            if (n>(K-i)*(B+N)) {
#ifdef DEBUG
   printf(" Check point IV\n");
   getchar();
#endif
               X[i].get_I(system); j = X[i].I;
               length = D[j][i+1].length; 
#ifdef DEBUG
   printf(" Check point V\n");
   printf(" X[%d].I %d\n",i,X[i].I);
   getchar();
#endif
               if (i==K) {
#ifdef DEBUG
   printf(" Check point VI\n");
   getchar();
#endif
                  X[i].prop(system);
#ifdef DEBUG
   printf(" Check point VII\n");
   getchar();
#endif            
               } else {//i!=K//
                  if (length==0) {
                     X[i].prop(system);
                  } else {
//                     ptemp = 0;
//                     if (pt_freq > ran1(seed)) {ptemp=1;}
                     if (pee > ran1(seed)) {
                       ith = (int)((ran1(seed)-eps)*((double)length))+1;     
                       if (!ptemp) {
#ifdef DEBUG
   printf(" Check point VIII\n");
   printf(" ith %d\n",ith);
   printf(" i: %d, j: %d \n",i,j); 
   for (int iii=1;iii<=D[j][i+1].length;iii++) {
     printf("D[%d][%d].stock[%d].epot: %g\n",j,i+1,iii,D[j][i+1].stock[iii].epot);
   }
   getchar();
#endif
                          y = D[j][i+1].stock[ith];
#ifdef DEBUG
   printf(" Check point IX\n");
   printf("y.epot %g\n",y.epot);
   getchar();
#endif
                       } else {
#ifdef DEBUG
   printf(" Check point X\n");
   getchar();
#endif
                          y = X[i+1];
#ifdef DEBUG
   printf(" Check point XI\n");
   getchar();
#endif
                       }
#ifdef DEBUG
   printf(" Check point XII\n");
   getchar();
#endif
                       y_pot   = y.potential(system);
                       x_pot   = X[i].potential(system);
                       pi_iy   = exp(-y_pot/T[i]);
                       pi_ix   = exp(-x_pot/T[i]);
                       pi_ip1y = exp(-y_pot/T[i+1]);
                       pi_ip1x = exp(-x_pot/T[i+1]);
                       pacc    = MIN(1.0,pi_iy*pi_ip1x/(pi_ix*pi_ip1y));
#ifdef DEBUG
   printf(" Check point XIII\n");
   getchar();
#endif
                       if (!ptemp) {
                          X[i].ee_jump(pacc,y,seed);
                       } else {
                          X[i].nptprop += 1;
                          if ( pacc > ran1(seed) ) {
                             X[i+1] = X[i];
                             X[i] = y;
                             X[i].nptacc += 1;
                          }
                       }    
                     } else {
                       X[i].prop(system);
                     } 
#ifdef DEBUG
   printf(" Check point XIV\n");
   getchar();
#endif
                  } 
               }//i!=K//
               if (n>(K-i)*(B+N)+B) {
#ifdef DEBUG
   printf(" Check point XV\n");
   getchar();
#endif
                  X[i].get_I(system); j = X[i].I;
#ifdef DEBUG
   printf(" Check point XVI\n");
   printf(" X[%d].I %d\n",i,X[i].I);
   printf(" X[%d].pos.epot %g\n",i,X[i].pos.epot);
   getchar();
#endif
                  D[j][i].add(X[i],seed);
#ifdef DEBUG
   printf(" Check point XVII\n");
   for (int ii=1;ii<=D[j][i].length;ii++) {
     printf("D[%d][%d].stock[%d].epot: %g\n",j,i,ii,D[j][i].stock[ii].epot);
   }
   getchar();
#endif
               }
            }
        }
        if ( (n>(K)*(B+N)) && ((n % nstat) == 0) ) {
#ifdef DEBUG
   printf(" Check point XVIII\n");
   getchar();
#endif
           output(X,system);           
#ifdef DEBUG
   printf(" Check point IX\n");
   getchar();
#endif
        }
    }//end_MC// 

    statistics(X,system);                

}
