#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"

void conf_sampl_pt( System &system ) {

    int i,j,n,k,ith;
    long  *seed = &(system.general.seed);
// system parameters
    int    nstep_mc = system.general.nstep_mc;
    int    nstat    = system.general.nstat;
    double pee      = system.general.pee;
    double length,pacc;
    double x_pot,y_pot;
    Coord  y;
// burn in periods
    int B = system.general.B;
    int N = system.general.N;
// MH Chain 
    int K  =  system.general.n_chains_mc;
    Chain *X; 
    X = new Chain[K+1];
    double T[K+1];
    double pi_iy,pi_ix,pi_ip1y,pi_ip1x;

    double pi_iy_p_ix;
    double pi_ip1x_p_ip1y;
// Initialize

    y.setup(system);
 
    for (k=0;k<=K;k++) {
        X[k].setup(k,system); 
        T[k] = system.energy_part.T[k];
    }

// MC Chain
    for (n=1;n<=nstep_mc;n++) {
        for (i=K;i>=0;i--) {
            if (n>(K-i)*(B+N)) {
               if (i==K) {
                  X[i].prop(system);             
               } else {//i!=K//
                     if (pee > ran1(seed)) {
		       ran1(seed);     
                       y = X[i+1];                         
                       y_pot   = y.potential(system);
                       x_pot   = X[i].potential(system);
                       pi_iy_p_ix  = (x_pot-y_pot)/T[i];
                       pi_ip1x_p_ip1y = (x_pot-y_pot)/T[i+1]; 
                       pacc    = MIN(1.0,exp(pi_iy_p_ix)*exp(pi_ip1x_p_ip1y));
                          X[i].nptprop += 1;
                          if ( pacc > ran1(seed) ) {
                             X[i+1] = X[i];
                             X[i] = y;
                             X[i].nptacc += 1;
                          }
                     } else {
                       X[i].prop(system);
                     } 
               }//i!=K// 
            }
        }
        if ( (n>(K)*(B+N)) && ((n % nstat) == 0) ) { 
           system.general.istep = n;
           output(X,system);            
        }
    }//end_MC//  
    statistics(X,system); 
}
