#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"

#define DEBUG
#undef DEBUG
#define EX_DEBUG
#undef EX_DEBUG

void conf_sampl_ptrepswa( System &system ) {

    int i,j,n,k,ith;
    long  *seed = &(system.general.seed);
// system parameters
    int    nstep_mc = system.general.nstep_mc;
    int    nstat    = system.general.nstat;
    double pee      = system.general.pee;
    double length,pacc;
    double x_pot,y_pot;
    Coord  y;
// burn in periods
    int B = system.general.B;
    int N = system.general.N;
// MH Chain
#ifdef DEBUG
   printf(" Check point 0\n");
   getchar();
#endif 
    int K  =  system.general.n_chains_mc;
    Chain *X;
    X = new Chain[K+1];
    double T[K+1];
    double pi_iy,pi_ix,pi_ip1y,pi_ip1x;

    double pi_iy_p_ix;
    double pi_ip1x_p_ip1y;
// Initialize

#ifdef DEBUG
   printf(" Check point I\n");
   getchar();
#endif 

    y.setup(system);

#ifdef DEBUG
   printf(" Check point II\n");
   getchar();
#endif 
    for (k=0;k<=K;k++) {
#ifdef DEBUG
   printf(" Check point III\n");
   getchar();
#endif 
        X[k].setup(k,system);
#ifdef DEBUG
   printf(" Check point IV\n");
   getchar();
#endif 
        T[k] = system.energy_part.T[k];
    }

// MC Chain
    for (n=1;n<=nstep_mc;n++) {
        for (i=K;i>=0;i--) {
            if (n>(K-i)*(B+N)) {
               if (i==K) {
#ifdef DEBUG
   printf(" Check point V\n");
   getchar();
#endif 
                  X[i].prop(system);            
#ifdef DEBUG
   printf(" Check point VI\n");
   getchar();
#endif 
               } else {//i!=K//
                     if (pee > ran1(seed)) {
		       ran1(seed);     
                       y = X[i+1];                         
                       y_pot   = y.potential(system);
                       x_pot   = X[i].potential(system);
                       pi_iy_p_ix  = (x_pot-y_pot)/T[i];
                       pi_ip1x_p_ip1y = (x_pot-y_pot)/T[i+1];
                       pacc    = MIN(1.0,exp(pi_iy_p_ix)*exp(pi_ip1x_p_ip1y));
#ifdef EX_DEBUG
  printf("x_pot %g\n",x_pot);
  printf("y_pot %g\n",y_pot);
  printf("T[i] %g\n",T[i]);
  printf("T[i+1] %g\n",T[i+1]);

  printf("pi_iy %g\n",pi_iy);
  printf("pi_ix %g\n",pi_ix);
  printf("pi_ip1y %g\n",pi_ip1y);
  printf("pi_ip1x %g\n",pi_ip1x);
 
  printf("pacc %g\n",pacc);
  printf("pacc %g\n",pacc);
  getchar();
#endif
                          X[i].nptprop += 1;
                          if ( pacc > ran1(seed) ) {
#ifdef EX_DEBUG
  printf("accepted!!!!\n ",pacc);
  getchar();
#endif
                             X[i+1] = X[i];
                             X[i] = y;
                             X[i].nptacc += 1;
                          }
                     } else {
                       X[i].prop(system);
                     } 
               }//i!=K//
#ifdef DEBUG
   printf(" Check point VII\n");
   getchar();
#endif 
            }
        }
        if ( (n>(K)*(B+N)) && ((n % nstat) == 0) ) {
#ifdef DEBUG
   printf(" Check point VIII\n");
   getchar();
#endif 
           output(X,system);
#ifdef DEBUG
   printf(" Check point IX\n");
   getchar();
#endif 
        }
    }//end_MC// 

#ifdef DEBUG
   printf(" Check point X\n");
   getchar();
#endif 
    statistics(X,system);          
#ifdef DEBUG
   printf(" Check point XI\n");
   getchar();
#endif 
}
