#include "../include/standard.h"
#include "../include/typedefs.h"
#include "../include/definitions.h"
#include "../include/utillib.h"

#define DEBUG_OFF

/*=========================================================================*/
/*=========================================================================*/
void md( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

    int n, one;
    int* K              = &(system.general.n_chains_mc);
    int prop_type       = system.general.prop_type;
    int nstep_md        = system.general.nstep_md;
    int nstat           = system.general.nstat;
    double T            = system.general.T;

    Chain X;
                               
    char   err_msg[LINE_NCHARMAX];
    char   warn_msg[LINE_NCHARMAX];

/*-------------------------------------------------------------------------*/
/* 0) Incompatibilities and Warnings                                       */

    if ( (prop_type     != 1) )     {/* not cart   */
      sprintf(warn_msg, "\\simulation_typ{md} is only performed in \n"
                        "\\prop_type{cart} space");
      warnMessage(warn_msg);
    }/*endif*/
                     
/*-------------------------------------------------------------------------*/
/* 1) Initialize local parameters                                          */
 
/*-------------------------------------------------------------------------*/
/* 2) Initialize the "one member" chain                                    */

    (*K) = 0;
    X.setup((*K),system);

/*-------------------------------------------------------------------------*/
/* 3) MD                                                                   */

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* 3.A) Set up initial velocities                                          */
 
        X.pos.vel_sampl(system);

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* 3.B) Set up initial force                                               */
/*      and conformation                                                   */

        X.pos.force(system);
	X.pos.init_propose(system);
        
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* 3.C) perform md                                                         */

        one = 1;
        for (n=1;n<=nstep_md;n++) {  
             X.pos.move_md(system,one);
             X.pos.acc_propose();
             if (((n % nstat)==0)) {
                 system.general.istep = n;
	         output(&(X.pos),system);
                 X.pos.vel_sampl(system);
             }/*endif*/
        }/*endfor*/

// Output position if debug

#ifdef DEBUG
    output(&(X.pos),system);
#endif

/*-------------------------------------------------------------------------*/
} /*end routine */
/*-------------------------------------------------------------------------*/

