#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"
#include "../include/utillib.h"

#define DEBUG

/*=========================================================================*/
/*=========================================================================*/
void normal_mode_stg( System &system )
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

    int i,j;
    int natom, nlownm, ntors_tr;

    double T        = system.general.T;

    Chain X;


/*-------------------------------------------------------------------------*/
/* I) get and diagonalize the hessian                                      */

// Initialize
    X.pos.setup(system,T);

// Minimize
    X.pos.move_tomin(system);

// Get the Hessian
    X.pos.get_hessian_stg(system);

// Solve Hessian
    X.pos.diagon_hessian(system);

/*-------------------------------------------------------------------------*/
/* II) write out small fluctuations in top 5/10 % low energy modes         */

  LINE
  LINE
  print_doubleline();
  printf(" constructing staging backbone cartesian normal modes \n");
  print_line(); 


  if (system.general.prop_type==1) {/*cartesian*/
    natom  = X.pos.natm_bb;
    nlownm = (int)(0.05*3*natom);                  /* 5 % of all modes  */
    if (nlownm<6) {nlownm = (int)(0.4*3*natom);}   /* 20 % of all modes */
    printf("output fluctuations in top %d low energy cartesian modes\n",nlownm);
    X.pos.update_xyz(); 
    for (j=3*natom;j>=(3*natom-nlownm);j--) {
       for (i=1;i<=3*natom;i++) {
           X.pos.ubbnm[i] = 0.0;
       }
       X.pos.ubbnm[j] = 0.0;
       for (i=1;i<=10;i++) {
	 //            X.pos.ubbnm[j] += ((double)i)*1.0; //0.1 1.0 10.0
	    X.pos.ubbnm[j] += i*1.0; //0.1 1.0 10.0
            X.pos.nm_transformUBBNMtoUBB();
            X.pos.update_uxbb_uybb_uzbb(system);
#ifdef DEBUG
       X.pos.write();
       getchar();
#endif
            X.pos.stage_transformUtoX();
#ifdef DEBUG
       X.pos.write();
       getchar();
#endif
            X.pos.acc_propose();
            output(&(X.pos),system);
            X.pos.update_xi_yi_zi();
            X.pos.stage_transformXtoU();
       }

    }
  }/*cartesian*/

  LINE
  LINE
  print_line();
  printf(" normal mode calculations completed \n");
  print_doubleline();

#ifdef DEBUG
   printf(" End of DEBUG Pos::normal_mode\n");
   getchar();
#endif 

/*-------------------------------------------------------------------------*/
} /*end routine */
/*-------------------------------------------------------------------------*/

