#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"

void seq_sampl_eemc( System &system ) {

    int i,j,n,k,ith;
    int ptemp;
    long  *seed = &(system.general.seed);
// system parameters
    int    nstep_mc = system.general.nstep_mc;
    int    nstat    = system.general.nstat;
    double pee      = system.general.pee;
    double length,pacc;
    Coord  y;
// burn in periods
    int B = system.general.B;
    int N = system.general.N;
// MH Chain
    int K  =  system.general.n_chains_mc;
    Chain *X; 
    X = new Chain[K+1];
    double T[K+1];
    double pi_iy,pi_ix,pi_ip1y,pi_ip1x;
// Disks
   Disk **D;
   for (int iD=0;iD<=K+1;iD++) {
        D[iD] = new Disk[K+1];
   }

    ptemp = 0;
// Initialize
    y.setup(system);
    for (k=0;k<=K;k++) {
        X[k].setup(k,system);
        T[k] = system.energy_part.T[k];
        for (j=0;j<=K;j++) {
	    D[k][j].setup(system);
	}
    }
// MC Chain
    for (n=1;n<=nstep_mc;n++) {
        for (i=K;i>=0;i--) {
            if (n>(K-i)*(B+N)) {
               X[i].get_I(system); j = X[i].I;
               length = D[j][i+1].length; 
               if (i==K) {
                  X[i].prop(system);            
               } else {//i!=K//
                  if (length==0) {
                     X[i].prop(system);
                  } else {
                     if (pee > ran1(seed)) {
                       ith = (int)(ran1(seed)*((double)length));     
                       if (!ptemp) {
                          y = D[j][i+1].stock[ith];
                       } else {
                          y = X[i+1];
                       }
                       pi_iy   = exp(-y.potential(system)/T[i]);
                       pi_ix   = exp(-X[i].potential(system)/T[i]);
                       pi_ip1y = exp(-y.potential(system)/T[i+1]);
                       pi_ip1x = exp(-X[i].potential(system)/T[i+1]);
                       pacc    = MIN(1.0,pi_iy*pi_ip1x/(pi_ix*pi_ip1y));
                       if (!ptemp) {
                          X[i].ee_jump(pacc,y,seed);
                       } else {
                          X[i].nptprop += 1;
                          if ( pacc > ran1(seed) ) {
                             X[i+1] = X[i];
                             X[i] = y;
                             X[i].nptacc += 1;
                          }
                       }    
                     } else {
                       X[i].prop(system);
                     } 
                  } 
               }//i!=K//
               if (n>(K-i)*(B+N)+B) {
                  X[i].get_I(system); j = X[i].I;
                  D[j][i].add(X[i],seed);
               }
            }
        }
        if ( (n>(K)*(B+N)) && ((n % nstat) == 0) ) {
           output(X,system);           
        }
    }//end_MC// 

    statistics(X,system);                

}
