#include "../include/standard.h"
#include "../include/typedefs.h"
#include "../include/definitions.h"
#include "../include/utillib.h"

#define DEBUG_OFF

/*=========================================================================*/
/*=========================================================================*/
void Pos::nm_copy(Pos *pos_target, Pos *pos_source)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

  int i, j;

  System *system = this->system_ptr;
  
  int prop_type = system->general.prop_type;
  int ntors_tr  = system->tors_defs.num_trans;

/*-------------------------------------------------------------------------*/
/* I) copy cartesian normal mode definition                                */

  if (prop_type==1) {/*cartesian*/
       for (i=1;i<=natom;i++) {     
            pos_target->xc[i] = pos_source->xc[i];
            pos_target->yc[i] = pos_source->yc[i];
            pos_target->zc[i] = pos_source->zc[i];
       }
       for (i=1;i<=3*natom;i++) { 
	    pos_target->xyzc[i]     = pos_source->xyzc[i]; 
            pos_target->lam_hess[i] = pos_source->lam_hess[i]; 
            for (j=1;j<=3*natom;j++) {
		 pos_target->hessian[i][j] = pos_source->hessian[i][j];
            }
       }     
   }/*cartesian*/

/*-------------------------------------------------------------------------*/
/* II) copy torsional normal mode definition                               */

   if (prop_type==2) {/*torsional*/
       for (i=1;i<=ntors_tr;i++) {
	    pos_target->tc[i]       = pos_source->tc[i];
            pos_target->lam_hess[i] = pos_source->lam_hess[i];
            for (j=1;j<=ntors_tr;j++) {
                 pos_target->hessian[i][j] = pos_source->hessian[i][j];
            }
       }
   }/*torsional*/

/*-------------------------------------------------------------------------*/
} /*end routine */
/*-------------------------------------------------------------------------*/

