#include "../../include/standard.h" 
#include "../../include/typedefs.h"
#include "../../include/definitions.h"
#include "../../include/utillib.h"
#include "../../include/cmalloc.h"

#define DEBUG
#undef DEBUG


/*=========================================================================*/
void Rotate_utils::setup()
/*-------------------------------------------------------------------------*/
/*      Allocating Rotate_utils variables                                  */
/*-------------------------------------------------------------------------*/
{/*begin routine*/  
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/* I) Allocate variables                                                   */

    int ndim = 3; 

    a           =   (double *)cmalloc(ndim*sizeof(double))-1; 
    b           =   (double *)cmalloc(ndim*sizeof(double))-1; 
    vec1scr_3x1 =   (double *)cmalloc(ndim*sizeof(double))-1;
    vec2scr_3x1 =   (double *)cmalloc(ndim*sizeof(double))-1;
    R           =   cmall_mat(1,ndim,1,ndim); 
    RT          =   cmall_mat(1,ndim,1,ndim); 
    A           =   cmall_mat(1,ndim,1,ndim); 
    B           =   cmall_mat(1,ndim,1,ndim); 
    C           =   cmall_mat(1,ndim,1,ndim); 
    I           =   cmall_mat(1,ndim,1,ndim); 
    mat1scr_3x3 =   cmall_mat(1,ndim,1,ndim);
    mat2scr_3x3 =   cmall_mat(1,ndim,1,ndim);

    r1          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    r2          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    r3          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    r4          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    r4_         =   (double *)cmalloc(ndim*sizeof(double))-1; 
    f1          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    f2          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    f3          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    f4          =   (double *)cmalloc(ndim*sizeof(double))-1; 

    dr4_dr1     =   cmall_mat(1,ndim,1,ndim); 
    dr4_dr2     =   cmall_mat(1,ndim,1,ndim); 
    dr4_dr3     =   cmall_mat(1,ndim,1,ndim); 

    e0          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e1          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e2          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e3          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e1_r        =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e2_r        =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e3_r        =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e1_Ar       =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e2_Ar       =   (double *)cmalloc(ndim*sizeof(double))-1; 
    e3_Ar       =   (double *)cmalloc(ndim*sizeof(double))-1; 

    ex          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    ey          =   (double *)cmalloc(ndim*sizeof(double))-1; 
    ez          =   (double *)cmalloc(ndim*sizeof(double))-1; 

    de1_dr2     =   cmall_mat(1,ndim,1,ndim); 
    de1_dr3     =   cmall_mat(1,ndim,1,ndim); 
    de2_dr1     =   cmall_mat(1,ndim,1,ndim); 
    de2_dr2     =   cmall_mat(1,ndim,1,ndim); 
    dey_de1     =   cmall_mat(1,ndim,1,ndim); 
    dey_de2     =   cmall_mat(1,ndim,1,ndim); 
    dex_dey     =   cmall_mat(1,ndim,1,ndim); 
    dex_dez     =   cmall_mat(1,ndim,1,ndim); 

    dex_dr1     =    cmall_mat(1,ndim,1,ndim); 
    dex_dr2     =    cmall_mat(1,ndim,1,ndim); 
    dex_dr3     =    cmall_mat(1,ndim,1,ndim); 
    dey_dr1     =    cmall_mat(1,ndim,1,ndim); 
    dey_dr2     =    cmall_mat(1,ndim,1,ndim); 
    dey_dr3     =    cmall_mat(1,ndim,1,ndim); 
    dez_dr1     =    cmall_mat(1,ndim,1,ndim); 
    dez_dr2     =    cmall_mat(1,ndim,1,ndim); 
    dez_dr3     =    cmall_mat(1,ndim,1,ndim); 

    dR_dr1x     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr1y     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr1z     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr2x     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr2y     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr2z     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr3x     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr3y     =    cmall_mat(1,ndim,1,ndim); 
    dR_dr3z     =    cmall_mat(1,ndim,1,ndim); 

    dRT_dr1x    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr1y    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr1z    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr2x    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr2y    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr2z    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr3x    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr3y    =    cmall_mat(1,ndim,1,ndim); 
    dRT_dr3z    =    cmall_mat(1,ndim,1,ndim);  

/*-------------------------------------------------------------------------*/
/* II) Initialize                                                          */

    I[1][1] = 1.0; I[1][2] = 0.0; I[1][3] = 0.0;
    I[2][1] = 0.0; I[2][2] = 1.0; I[2][3] = 0.0;
    I[3][1] = 0.0; I[3][2] = 0.0; I[3][3] = 1.0; 

/*-------------------------------------------------------------------------*/
}/*end routine*/
/*=========================================================================*/
