#include "../../include/standard.h" 
#include "../../include/typedefs.h"
#include "../../include/definitions.h"
#include "../../include/utillib.h"
#include "../../include/cmalloc.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Pos::stage_transformUtoX()
/*-------------------------------------------------------------------------*/
/*  transformation from staging (ux, uy, uz) to cartesian (x,y,z) space    */
/*                                                                         */
/*  Effected class variables:                                              */
/*  xi, yi, zi                                                             */
/*-------------------------------------------------------------------------*/
{/*begin routine*/  
/*-------------------------------------------------------------------------*/

 int iatm,level;                         

 System *system = this->system_ptr;                                       

 General   *general     = &(system->general);
 Stage_defs *stage_defs = &(system->stage_defs);
 int num_tr           =  stage_defs->num_trans;
 int *ityp_trans      =  stage_defs->ityp_trans; 
 int **ind_group      =  stage_defs->ind_trans;

/*-------------------------------------------------------------------------*/
/*                       Transformation loop                               */ 
/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/* I) U -> X transformation                                                */


   for (level = 1;level <= num_tr;level++) {/*backward half*/

       /* i) closed staging */
         if (ityp_trans[level] == 1) {
         stage_closed_transform(this,stage_defs,level,-1);  
         }/*endif*/
       /* i) open staging */
         if (ityp_trans[level] == 2) {
             stage_open_transform(this,stage_defs,level,-1);  
        }/*endif*/

   }/*end of backward half*/ 


/*-------------------------------------------------------------------------*/
/* I) Assign X from U                                                      */

  for (iatm=1;iatm<=natom;iatm++) {
       xi[iatm] = ux[iatm]; 
       yi[iatm] = uy[iatm]; 
       zi[iatm] = uz[iatm];
  }/*endfor*/



/*--------------------------------------------------------------------------*/
}/*                              End                                        */ 
/*--------------------------------------------------------------------------*/ 
