#include "../../include/standard.h" 
#include "../../include/typedefs.h"
#include "../../include/definitions.h"
#include "../../include/utillib.h"
#include "../../include/cmalloc.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Pos::stage_transformXtoU()
/*-------------------------------------------------------------------------*/
/*  transformation from cartesian (x,y,z) to staging (ux, uy, uz) space    */
/*                                                                         */
/*  Effected class variables:                                              */
/*  ux, uy, uz                                                             */
/*-------------------------------------------------------------------------*/
{/*begin routine*/  
/*-------------------------------------------------------------------------*/

 int iatm,level;                         

 System *system = this->system_ptr;                                       

 General   *general     = &(system->general);
 Stage_defs *stage_defs = &(system->stage_defs);
 int num_tr           =  stage_defs->num_trans;
 int *ityp_trans      =  stage_defs->ityp_trans; 
 int **ind_group      =  stage_defs->ind_trans;

/*-------------------------------------------------------------------------*/
/*                       Transformation loop                               */ 
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/* I) Initialize U position from X                                         */

  
  for (iatm=1;iatm<=natom;iatm++) {
       ux[iatm] = xi[iatm]; 
       uy[iatm] = yi[iatm]; 
       uz[iatm] = zi[iatm];
  }/*endfor*/

/*-------------------------------------------------------------------------*/
/* II) X - > U transformation                                              */


   for (level = num_tr;level >= 1;level--) {/*backward half*/

       /* i) closed staging */
        if (ityp_trans[level] == 1) {
         stage_closed_transform(this,stage_defs,level,1);  
         }/*endif*/

        /* i) open staging */
         if (ityp_trans[level] == 2) {
             stage_open_transform(this,stage_defs,level,1);  
         }/*endif*/

   }/*end of backward half*/ 

/*--------------------------------------------------------------------------*/
}/*                              End                                        */ 
/*--------------------------------------------------------------------------*/ 
