#include "../../include/standard.h" 
#include "../../include/typedefs.h"
#include "../../include/definitions.h"
#include "../../include/utillib.h"
#include "../../include/cmalloc.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Pos::tors_transformTtoX()
/*-------------------------------------------------------------------------*/
/*  transformation from torsional (r,theta,phi) to cartesian (x,y,z) space */
/*  along the predefined torsions available from  class system->tors_defs  */
/*                                                                         */
/*  Effected class variables:                                              */
/*  $i $ = {x,y,z}                                                         */
/*-------------------------------------------------------------------------*/
{/*begin routine*/  
/*-------------------------------------------------------------------------*/

 int level;                         

 System *system = this->system_ptr;                                       

 General   *general   = &(system->general);
 Tors_defs *tors_defs =   system->tors_defs_ptr;
 int num_tr           =  tors_defs->num_trans; 
 int **ind_group      =  tors_defs->ind_trans;

/*-------------------------------------------------------------------------*/
/*                       Transformation loop                               */ 
/*-------------------------------------------------------------------------*/

   for (level = 1;level <= num_tr;level++) {/*forward half*/
       /* i) z <- phi of primary dihedral */
          zi[ind_group[level][1]] = t[level];       
       /* ii) ungroup atoms */
          group(this,tors_defs,level,-1);
       /* iii) backward resolve */
          resolve(this,tors_defs,level,-1);
       /* vi) backward  rotate */
          rotate(this,tors_defs,level,-1); 
       /* v) backward translate */
          translate(this,tors_defs,level,-1);   
   }/*end of forward half*/

/*--------------------------------------------------------------------------*/
}/*                              End                                        */ 
/*--------------------------------------------------------------------------*/ 
