#include "../../include/standard.h" 
#include "../../include/typedefs.h"
#include "../../include/definitions.h"
#include "../../include/utillib.h"
#include "../../include/cmalloc.h"

#define DEBUG
#undef DEBUG

/*=========================================================================*/
void Pos::tors_transformXtoT()
/*-------------------------------------------------------------------------*/
/*  transformation from cartesian (x,y,z) to torsional (r,theta,phi) space */
/*  along the predefined torsions available from  class system->tors_defs  */
/*                                                                         */
/*  Effected class variables:                                              */
/*  $i $ = {x,y,z}                                                         */
/*-------------------------------------------------------------------------*/
{/*begin routine*/  
/*-------------------------------------------------------------------------*/

 int level;                         

 System *system = this->system_ptr;                                       

 General   *general   = &(system->general);
 Tors_defs *tors_defs =   system->tors_defs_ptr;
 int num_tr           =  tors_defs->num_trans; 
 int **ind_group      =  tors_defs->ind_trans;

/*-------------------------------------------------------------------------*/
/*                       Transformation loop                               */ 
/*-------------------------------------------------------------------------*/

   for (level = num_tr;level >= 1;level--) {/*backward half*/
       /* 1st three steps involve primary tors and group atoms */
       /* i)forward translate */
          translate(this,tors_defs,level,1);  
       /* ii)forward rotate */
          rotate(this,tors_defs,level,1); 
       /* iii)forward resolve */
          resolve(this,tors_defs,level,1);
       /* iv) group atoms */
          group(this,tors_defs,level,1);
       /* v) phi <- z of primary dihedral */
          t[level] = zi[ind_group[level][1]];       
   }/*end of backward half*/ 

/*--------------------------------------------------------------------------*/
}/*                              End                                        */ 
/*--------------------------------------------------------------------------*/ 
