#include "../include/standard.h" 
#include "../include/typedefs.h"
#include "../include/definitions.h"
#include "../include/utillib.h"
#include "../include/cmalloc.h"

/*-------------------------------------------------------------------------*/
/*                          translate                                      */
/* type ==  1 : position forward                                           */
/* type == -1 : position backward                                          */
/* type ==  2 : position + force forward                                   */
/* type == -2 : position + force backward                                  */
/*-------------------------------------------------------------------------*/
/*ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc*/
/*-------------------------------------------------------------------------*/

void translate(Pos *pos,Tors_defs *tors_defs,int i_trans,int type)  

/*-------------------------------------------------------------------------*/
   {/*begin*/ 
/*-------------------------------------------------------------------------*/

  int j1,j2,j3,j4; 
  int iatm,jatm;
 
  /*       For REPSWA       */
  /* double *ux  = pos.ux;  */
  /* double *uy  = pos.uy;  */
  /* double *uz  = pos.uz;  */
  /* double *fux = pos.fux; */
  /* double *fuy = pos.fuy; */
  /* double *fuz = pos.fuz; */
 
  double *ux  = pos->xi;
  double *uy  = pos->yi;
  double *uz  = pos->zi;
  double *fux = pos->fx;
  double *fuy = pos->fy;
  double *fuz = pos->fz;

  int **ind_prim_tors = tors_defs->ind_prim_tors;
  int **ind_group     = tors_defs->ind_trans;
  int *natm_group     = tors_defs->natm_trans;

/*-------------------------------------------------------------------------*/
/* Assumes atom 4 is in the group checked in interface                     */
   
   j1 = ind_prim_tors[i_trans][1]; 
   j2 = ind_prim_tors[i_trans][2]; 
   j3 = ind_prim_tors[i_trans][3]; 

   switch(type){
     
     case -2 : 
        for (iatm=1;iatm<=natm_group[i_trans];iatm++) {/*group atoms*/ 
            jatm = ind_group[i_trans][iatm]; 
            ux[jatm] = ux[jatm] + ux[j3];
            uy[jatm] = uy[jatm] + uy[j3];
            uz[jatm] = uz[jatm] + uz[j3];
            fux[j3]  = fux[j3] - fux[jatm];
            fuy[j3]  = fuy[j3] - fuy[jatm];
            fuz[j3]  = fuz[j3] - fuz[jatm];
        }/*group atoms*/
        break;
     case -1 : 
        for (iatm=1;iatm<=natm_group[i_trans];iatm++) {/*group atoms*/ 
            jatm = ind_group[i_trans][iatm]; 
            ux[jatm] = ux[jatm] + ux[j3];
            uy[jatm] = uy[jatm] + uy[j3];
            uz[jatm] = uz[jatm] + uz[j3];
        }/*group atoms*/
        break;
     case  1 : 
        for (iatm=1;iatm<=natm_group[i_trans];iatm++) {/*group atoms*/ 
            jatm = ind_group[i_trans][iatm]; 
            ux[jatm] = ux[jatm] - ux[j3];
            uy[jatm] = uy[jatm] - uy[j3];
            uz[jatm] = uz[jatm] - uz[j3];
        }/*group atoms*/
        break;
     case  2 : 
        for (iatm=1;iatm<=natm_group[i_trans];iatm++) {/*group atoms*/ 
            jatm = ind_group[i_trans][iatm]; 
            ux[jatm] = ux[jatm] - ux[j3];
            uy[jatm] = uy[jatm] - uy[j3];
            uz[jatm] = uz[jatm] - uz[j3];
            fux[j3]  = fux[j3] + fux[jatm];
            fuy[j3]  = fuy[j3] + fuy[jatm];
            fuz[j3]  = fuz[j3] + fuz[jatm];
        }/*group atoms*/
        break;

   }/* switch*/ 

/*-------------------------------------------------------------------------*/
  }/*end of translate*/
/*-------------------------------------------------------------------------*/
